import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;



public class GraphicApp extends JFrame {
	private boolean PLAYERS = true; 
	private boolean FLAGS = true;
	private boolean YOURSELF = true;
	private boolean BALL = true;
	private JButton togglePlayers, toggleFlags, toggleYourself, toggleBall;
	//private JLabel promptX,promptY;
	//private JTextField inputX, inputY;
	private JPanel GUI;
	private Container c;
	private Visualisation visual;
	
	
	public GraphicApp(int unum){
		
		//gibt dem JFrame einen Namen
		super("Visualisierung des Spielers " + unum);
		
		//Instanziiere Innere Klasse ActionEventHandler
		ActionEventHandler handler = new ActionEventHandler();
		
		//Setup der Benutzerfuehrung	
		GUI = new JPanel();
		GUI.setLayout(new FlowLayout());
		
		/*
		promptX = new JLabel("X-Koordinate (-52.5 .. 52.5) :");
		GUI.add(promptX);
		inputX = new JTextField(4);
		GUI.add(inputX);
		promptY = new JLabel("Y-Koordinate (-34 .. 34) :");
		GUI.add(promptY);
		inputY = new JTextField(4);
		GUI.add(inputY);
		*/
		
		toggleYourself = new JButton("toggle yourself");
		toggleYourself.addActionListener(handler);
		GUI.add(toggleYourself);
					
		togglePlayers = new JButton("toggle players");
		togglePlayers.addActionListener(handler);
		GUI.add(togglePlayers);
		
		toggleBall = new JButton("toggle ball");
		toggleBall.addActionListener(handler);
		GUI.add(toggleBall);
		
		toggleFlags = new JButton("toggle flags"); 
		toggleFlags.addActionListener(handler);
		GUI.add(toggleFlags);
		
		//init Visualisation
		visual = new Visualisation(unum, YOURSELF, PLAYERS, BALL, FLAGS);
		visual.setBackground(Color.green.darker());

		
		//haenge Visualisation und GUI an Container c
		c = getContentPane();
		c.setLayout(new BorderLayout());
		c.add(GUI, BorderLayout.SOUTH);
		c.add(visual, BorderLayout.CENTER);
			
		setSize(480,400);
		//ruft paint() auf und bringt so alles auf den Bildschirm
		setVisible(true);
	}	

	public void update(Vector v){
		visual.draw(v,YOURSELF,PLAYERS,BALL,FLAGS);
	}
	
	
	
	
	//Innere Klasse ActionEventHandler behandelt Events
	private class ActionEventHandler implements ActionListener {
		private double x = 0, y = 0;

		public void actionPerformed(ActionEvent e){
			if(e.getSource() == toggleYourself){
				YOURSELF = toggle(YOURSELF);
			}
			else if(e.getSource() == togglePlayers){
				PLAYERS = toggle(PLAYERS);
			}
			else if(e.getSource() == toggleBall){
				BALL = toggle(BALL);
			}
			else if(e.getSource() == toggleFlags){
				FLAGS = toggle(FLAGS);
			}
		}



		private boolean toggle(boolean bo){
			if(bo){
				bo = false;
			}
			else{
				bo = true;
			}
			return bo;
		}
	}//end of inner class ActionEventHandler


	public static void main(String args[]){
		
		GraphicApp app = new GraphicApp(100);
		
		app.addWindowListener(
			new WindowAdapter(){
				public void windowClosing(WindowEvent e){
			//		System.out.println("DON'T YOU LIKE OUR VISUALISATION?!?");
				}
			}
		);
	}
}//end of class GraphicApp