import java.util.*;
import java.lang.*;

public class Player extends Thread
{
		/** the actual timestamp of last visual event received */
		private int time = -1;
		private int uniformNumber;
		private String spielRichtung, teamName, formation;
		private WeltModel WM;
		private DataCore DC;    
		private Actor actor;

		private int[] visualList = new int[11];
		
						
		//soll die Visualisierung gezeichnet werden?
		private boolean drawVisual;
		
		//constant defining the START status 
		final private int START = 0;
	
		//constant defining the PLAYING status
		final private int PLAYING = 1;
		
		//constant defining the GOAL status
		final private int GOAL = 2;
		
		//current status the player is in		
		private int status = START;

		//true if the player is to far away from his startingPosition
		private boolean mispositioned = false;
		
		
		
		public Player(String servername, int serverport, String teamName, int[] visualList, String formation, boolean goalie)
		{
			CommunicationChannel communication = new CommunicationChannel(servername, serverport);
			actor = new Actor(communication, goalie);
			this.visualList = visualList;				
			this.teamName = teamName;
			this.formation = formation;
		}


		//run-method for the thread player 	 
		public void run()
		{		
			
			Event event = null;

			//REGISTER player at Server
			//Identifikation[1] enthaelt die dem Player vom Server zugeteilte nummer
			//Identifikation[0] enthaelt die Spielfeldseite ( 'l' oder 'r')
			String[] Identifikation = actor.init(teamName);
			uniformNumber = Integer.parseInt(Identifikation[1]);
			spielRichtung = Identifikation[0];
			
			// hier wird gecheckt, ob die vom Server zugewiesene Nummer visualisiert werden soll
			for(int i = 0; i < visualList.length; i++)
			{
				if(uniformNumber == visualList[i])
				{
					drawVisual = true;
				}
			}
			
		
			DC = new DataCore(uniformNumber, spielRichtung, formation);			
			WM = new WeltModel(drawVisual, uniformNumber, spielRichtung);
			

			//GAME LOOP
			while (true) 
			{
				event = actor.event();
				if (event.isVisualEvent())
				{	
					VisualEvent ve = (VisualEvent)event;
					
					//aktualisiere zeit
					time = ve.time();
					
					//aktualisiere das WeltModel
					WM.update(ve);
				}

				else if (event.isBodyEvent()) 
				{
					BodyEvent be = (BodyEvent)event;
					
					//update the timestamp
					time = be.time();				
					
					// only act upon receipt of a body sense event
					play();				
				}
//**NEU**NEU**NEU***************************************************************************
				else if(event.isHearEvent())
				{
					HearEvent he = (HearEvent)event;
					if(he.isGoalKickOff())					
					{
						//System.out.println("Jawoll, es gibt ein hear event mit goal_kick_off !!");
						status = PLAYING;
						//System.out.println("Status = " + status + "sollte 2 sein ?!");
						
					}
					else
					if(he.isBeforeKickOff())
					{
						//System.out.println("Jetzt gibts Seitenwechsel !!!");
						status = START;
						
					}
					else
					if(he.isPlayOn())
					{
						status = PLAYING;
					}
	                else
	                if(he.isGoal())
	                {
	                	status = GOAL;
	                }
	                				
				} 
//ENDE**NEU**NEU**NEU***************************************************************************		
					
			}
		}

		
		private void play()
		{	
			ReferencePoint ball;
			ReferencePoint player;
			
			//System.out.println("Status ist jetzt :" + status);
			
			switch (status) 
			{							
				
								
				case GOAL:
					
					
					
					if(formation.equals("def"))
					{					
						if(spielRichtung.equals("r"))
						{
							actor.move(DC.startingP(uniformNumber)[0],DC.startingP(uniformNumber)[1]); 
						}
						else
						{						
							actor.move(-DC.startingP(uniformNumber)[0],-DC.startingP(uniformNumber)[1]);
						}
						
						actor.changeView("normal","high");
						status = GOAL;										
					
					}
					else
					{
						
						switch(uniformNumber)
						{
							case 1:
							case 2:
							case 3:
							case 4:
							case 5:
							case 6:						
							case 8:
								if(spielRichtung.equals("r"))
								{
									actor.move(DC.startingP(uniformNumber)[0],DC.startingP(uniformNumber)[1]); 
								}
								else
								{						
									actor.move(-DC.startingP(uniformNumber)[0],-DC.startingP(uniformNumber)[1]);
								}
								
							break;
							
							case 7:
								if(spielRichtung.equals("r"))
								{
									actor.move((DC.startingP(uniformNumber)[0] - 5),DC.startingP(uniformNumber)[1]); 
								}
								else
								{						
									actor.move((-DC.startingP(uniformNumber)[0] - 5),-DC.startingP(uniformNumber)[1]);
								}
								
							break;
													
								
							case 9:
							case 11:
								
								if(spielRichtung.equals("r"))
								{
									actor.move((DC.goalP(uniformNumber)[0]),DC.goalP(uniformNumber)[1]); 
								}
								else
								{						
									actor.move(-(DC.goalP(uniformNumber)[0]),-DC.goalP(uniformNumber)[1]);
								}
									
							break;			
								
								
							
							case 10:
									if(spielRichtung.equals("r"))
								{
									actor.move((DC.goalP(uniformNumber)[0]),DC.goalP(uniformNumber)[1]); 
								}
								else
								{						
									actor.move(-(DC.goalP(uniformNumber)[0]),-DC.goalP(uniformNumber)[1]);
								}
							
							
							break;							
						} //end switch(uniformNumber)
					
						actor.changeView("normal","high");
					//	status = GOAL;
					
						break;
					} //END ELSE	
					
				
				
				case START:
					
					
					if(spielRichtung.equals("r"))
					{
						actor.move(DC.startingP(uniformNumber)[0],DC.startingP(uniformNumber)[1]); 
					}
					else
					{						
						actor.move(-DC.startingP(uniformNumber)[0],-DC.startingP(uniformNumber)[1]);
					}
					
					
					actor.changeView("normal","high");
					status = PLAYING;
				
					break;
					
					
										        
				case PLAYING:
								
					if(WM.player() != null)
					{
						player = WM.player();
						
						
						if(!mispositioned)
								{
									if(WM.ball() == null)
									{
										actor.turn(25);// ball is not visible ergo try to find it
									}
									else
									{
										ball = WM.ball();
										
										// turn to ball if necessary but only if synchronized to t-2
										if (Math.abs(ball.direction()) > 1.0 && ball.time() == (time-2)) 
										{											
											actor.turn(ball.direction());	
										}										
										else  //is the ball in my active zone?										
										if(DC.inActZone(ball.getX(),ball.getY()))
										{								
									
											// check the distance
											if(ball.distance() < 1.0)
											{
												if(formation.equals("def"))
												{
													if(spielRichtung.charAt(0) == 'l')
													{												
														actor.pass((WM.distanceTo(new double[] {-52.5,0.0}) * 3 ), player, (new double[] {-52.5,0.0}));
													}
													else
													{
														actor.pass((WM.distanceTo(new double[] {+52.5,0.0}) * 3 ), player, (new double[] {+52.5,0.0}));
													}
												}
												else
												{	
														
														
													switch(uniformNumber)
													{
														case 1:
															if(spielRichtung.charAt(0) == 'l')
															{												
																actor.pass((WM.distanceTo(DC.startingP(6)) * 3), player, (DC.startingP(6)));
															}
															else
															{
																actor.pass((WM.distanceTo(DC.startingP(6)) * 3), player, (DC.startingP(6)));
															}
															
														break;
															
														case 2:
															if(spielRichtung.charAt(0) == 'l')
															{												
																actor.pass((WM.distanceTo(DC.startingP(8)) * 3), player, (DC.startingP(8)));
															}
															else
															{
																actor.pass((WM.distanceTo(DC.startingP(8)) * 3), player, (DC.startingP(8)));
															}
															
														break;
														
														case 3:
															if(spielRichtung.charAt(0) == 'l')
															{												
																actor.pass((WM.distanceTo(DC.startingP(9)) * 3), player, (DC.startingP(9)));
															}
															else
															{
																actor.pass((WM.distanceTo(DC.startingP(9)) * 3), player, (DC.startingP(9)));
															}
															
														break;
														
														case 4:
															if(spielRichtung.charAt(0) == 'l')
															{												
																actor.pass((WM.distanceTo(DC.startingP(6)) * 3), player, new double[] {(DC.startingP(6)[0] - 10),(DC.startingP(6)[1])});
																//System.out.println("Power = " + (WM.distanceTo(DC.startingP(6)) * 3) );
																//System.out.println("ZielPos1 = " + DC.startingP(6)[0] );
																//System.out.println("ZielPosPlus = " + (DC.startingP(6)[0] - 10));
															}
															else
															{
																actor.pass((WM.distanceTo(DC.startingP(8)) * 3), player, new double[] {(DC.startingP(6)[0] + 10),(DC.startingP(8)[1])});
																//System.out.println("Power = " + (WM.distanceTo(DC.startingP(6)) * 3) );
																//System.out.println("ZielPos1 = " + DC.startingP(6)[0] );
																//System.out.println("ZielPosPlus = " + (DC.startingP(6)[0] + 10));
															}
															
														break;
														
														case 5:
															if(spielRichtung.charAt(0) == 'l')
															{												
																actor.pass((WM.distanceTo(DC.startingP(11)) * 3), player, (DC.startingP(11)));
															}
															else
															{
																actor.pass((WM.distanceTo(DC.startingP(11)) * 3), player, (DC.startingP(11)));
															}
															
														break;
														
														case 6:
															if(spielRichtung.charAt(0) == 'l')
															{												
																actor.pass((WM.distanceTo(DC.startingP(9)) * 3), player, (DC.startingP(9)));
															}
															else
															{
																actor.pass((WM.distanceTo(DC.startingP(9)) * 3), player, (DC.startingP(9)));
															}
															
														break;												
														
														case 8:
															if(spielRichtung.charAt(0) == 'l')
															{												
																actor.pass((WM.distanceTo(DC.startingP(11)) * 3), player, (DC.startingP(11)));
															}
															else
															{
																actor.pass((WM.distanceTo(DC.startingP(11)) * 3), player, (DC.startingP(11)));
															}
															
														break;
														
														case 7:
														case 9:												
														case 10:												
														case 11:
															if(spielRichtung.charAt(0) == 'l')
															{												
																actor.pass(100, player, new double[] {-52.5, 0});
															}
															else
															{
																actor.pass(100, player, new double[] {52.5, 0});
															}
															
														break;
														
													} //end switch	
												}										
												
											} //end if ball distance is ok
											else
											{									
												//TODO: adjust the dash power to be not to strong nor to weak.
												actor.dash(20*ball.distance() + 10);		
											}	
										}							
										else  //ball is neither near nor is the player at his position hence...										
										if(ball.distance()>20 && WM.distanceTo(DC.startingP(uniformNumber)) > 4)
								   		{
								   			mispositioned = true;
								   		}
								   		
									}//end of else(ball == null)
								}//end of if(!mispositioned)						
								else  //the player is mispositioned...
								{							
										
										
										//get the relative Direction to "shouldbethere" position
										double direction = WM.directionTo(DC.startingP(uniformNumber));
								
										//turn if necessary but only with t-2 time info
										if(Math.abs(direction) > 10.0 && player.time() == (time-2))
										{											
											actor.turn(direction);
										}								
										else 
										if(WM.distanceTo(DC.startingP(uniformNumber)) > 10.0)
									 	{	
											actor.dash(100);
										}
										else 
										if(WM.distanceTo(DC.startingP(uniformNumber)) > 2)
									 	{	
											actor.dash(50);
										}
									 	else
								     	{
											mispositioned = false;
										}				
							
								}	//end of else(!mispositioned)								
				
					}	//end if(WM.player() == null)
										
					break;
				
			}	//end of switch(status)
			
		}	//end of play()


}	//end of class


