import java.util.*;

public class WeltModel
{
    private Flag[] flags =
	{
		//center flag
		new Flag("f c",0.0,0.0),
		//left outer box
		new Flag("f l t 30",-57.5,-30.0),
		new Flag("f l t 20",-57.5,-20.0),
		new Flag("f l t 10",-57.5,-10.0),
		new Flag("f l 0",-58.5,0.0),
		new Flag("f l b 10",-57.5,10.0),
		new Flag("f l b 20",-57.5,20.0),
		new Flag("f l b 30",-57.5,30.0),
		//right outer box
		new Flag("f r t 30",57.5,-30.0),
		new Flag("f r t 20",57.5,-20.0),
		new Flag("f r t 10",57.5,-10.0),
		new Flag("f r 0",57.5,0.0),
		new Flag("f r b 10",57.5,10.0),
		new Flag("f r b 20",57.5,20.0),
		new Flag("f r b 30",57.5,30.0),
		//top outer box
		new Flag("f t l 50",-50.0,-39.0),
		new Flag("f t l 40",-40.0,-39.0),
		new Flag("f t l 30",-30.0,-39.0),
		new Flag("f t l 20",-20.0,-39.0),
		new Flag("f t l 10",-10.0,-39.0),
		new Flag("f t 0",0.0,-39.0),
		new Flag("f t r 10",10.0,-39.0),
		new Flag("f t r 20",20.0,-39.0),
		new Flag("f t r 30",30.0,-39.0),
		new Flag("f t r 40",40.0,-39.0),
		new Flag("f t r 50",50.0,-39.0),
		//bottom outer box
		new Flag("f b l 50",-50.0,39.0),
		new Flag("f b l 40",-40.0,39.0),
		new Flag("f b l 30",-30.0,39.0),
		new Flag("f b l 20",-20.0,39.0),
		new Flag("f b l 10",-10.0,39.0),
		new Flag("f b 0",0.0,39.0),
		new Flag("f b r 10",10.0,39.0),
		new Flag("f b r 20",20.0,39.0),
		new Flag("f b r 30",30.0,39.0),
		new Flag("f b r 40",40.0,39.0),
		new Flag("f b r 50",50.0,39.0),
		//left goal box
		new Flag("f g l t",-52.5,-7.01),
		new Flag("g l",-52.5,0.0),
		new Flag("f g l b",-52.5,7.01),
		//right goal box
		new Flag("f g r t",52.5,-7.01),
		new Flag("g r",52.5,0.0),
		new Flag("f g r b",52.5,7.01),
		//top inner box
		new Flag("f l t",-52.5,-34.0),
		new Flag("f c t",0.0,-34.0),
		new Flag("f r t",52.5,-34.0),
		//bottom inner box
		new Flag("f l b",-52.5,34.0),
		new Flag("f c b",0.0,34.0),
		new Flag("f r b",52.5,34.0),
		//left penalty area
		new Flag("f p l t",-36.0,-20.175),
		new Flag("f p l c",-36.0,0.0),
		new Flag("f p l b",-36.0,20.175),
		//right penalty area
		new Flag("f p r t",36.0,-20.175),
		new Flag("f p r c",36.0,0.0),
		new Flag("f p r b",36.0,20.175),
	};
	
			
	//Contains the time of the last update
	private	int time = -1;	
	
	//This equals the uniformNumber of superclass Player
	private int uniformNumber;
		
	//Hold information on yourself
	private ReferencePoint player;
	
	//Holds information about the ball
	private ReferencePoint ball;
	
	//Enthaelt die spielRichtung
	private String spielRichtung;
	
	//Vector mit ReferencePoints (RP) deren absoluten Daten bekannt sind
	private Vector absRPList = new Vector();
	
	//Vector mit mobilen ObjectPerception (OP) Objekten die noch keine abs. daten haben  
	private Vector relOPList = new Vector();
	
	//Accounts for the Players visualisation;
	private GraphicApp graphics = null;
		
	public ReferencePoint ball(){return this.ball;}
	
	public ReferencePoint player(){return this.player;}
	
	
	
	public WeltModel(boolean drawVis, int unum, String spielRichtung)
	{
		this.spielRichtung = spielRichtung;
		//Soll das Weltmodel visualisiert werden?
		if(drawVis)
		{
			graphics = new GraphicApp(unum);
		}
	}
		
	
	/**
	 * Methode um bei gegebenem Spieler die Entfehrnung zu seinem 
	 * sichtbaren Ziel zu berechnen.
	 **/
	public double distanceTo(double[] targetCoord)
	{
 		double x = player.getX() - targetCoord[0];
 		double y = player.getY() - targetCoord[1];
 		//a^2 + b^2 = c^2
 		double distance = Math.sqrt((x*x) + (y*y));
 		return distance;
 	}
	
	
	/**
	 * Methode um einem gegebenen Spieler einen relativen Winkel zu seinem 
	 * sichtbaren Ziel zu liefern
	 **/
	public double directionTo(double[] targetCoord)
	{	
		double dir = 444;//dummy value
		//compute the difference in coordinates of player and target
	 	double x = player.getX() - targetCoord[0];
	 	double y = player.getY() - targetCoord[1];
	 	//compute the inverse tangens
	 	dir = Math.toDegrees(Math.atan(y/x));
	 	switch(spielRichtung.charAt(0))
	 	{
		 	case 'r':
			 	if(x>0 && y<0)
			 		dir = dir + 180;
			 	if(x>0 && y>0)
			 		dir = dir - 180;
			 	if(x<0 && y<0)
			 		dir = dir; 
			 	if(x<0 && y>0)
			 		dir = dir;
			 	break;
			 	
		 	case 'l':
			 	if(x>0 && y<0)
			 		dir = dir;
			 	if(x>0 && y>0)
			 		dir = dir;
			 	if(x<0 && y<0)
			 		dir = dir + 180; 
			 	if(x<0 && y>0)
			 		dir = dir - 180;
				break;
				
 		}//end of switch()
 		//korrigiere "dir" um den absoluten Winkel des spielers
		dir = dir - player.direction();
 		//normalisiere
		if(dir>180)
			dir = dir - 360;
		if(dir<-180)
			dir = dir + 360;
 		return dir;
 	}//end of directionTo()
	
	
	/** 
	 * Methode zur Berechnung des absoluten Winkels. Sie benoetig die 
	 * spielRichtung und eine Linie.
	 * Die spielRichtung ist eine Instanzvariable der Klasse WeltModel 
	 */
	private int absDirection(ObjectPerception line)
	{	
		int tempDir = 361;//dummy value
					
		switch(spielRichtung.charAt(0))
		{		  
			case 'r':	
				switch(line.name().charAt(2))
				{
					case 't':
						if(line.direction() >=0){tempDir=(int)(0 - line.direction());}
						else{tempDir =(int)( -180 - line.direction());} 
						break;
					case 'b':
					  	if(line.direction() >=0){tempDir=(int)(180 - line.direction());}
				  		else{tempDir =(int)( 0 - line.direction());}
				  		break;
					case 'l':
					  	if(line.direction() >=0){tempDir=(int)(-90 - line.direction());}
				  		else{tempDir =(int)( 90 - line.direction());}
				  		break;
					case 'r':
				  		if(line.direction() >=0){tempDir=(int)(90 - line.direction());}
				 	 	else{tempDir =(int)( -90 - line.direction());}
						break;
				}
				break;
		  
		  case 'l':
				switch(line.name().charAt(2))
				{
					case 't':
						if(line.direction() >=0){tempDir=(int)(180 - line.direction());}
						else{tempDir =(int)( 0 - line.direction());} 
						break;
					case 'b':
				  		if(line.direction() >=0){tempDir=(int)(0 - line.direction());}
				  		else{tempDir =(int)( -180 - line.direction());}
				  		break;
					case 'l':
				  		if(line.direction() >=0){tempDir=(int)(90 - line.direction());}
				  		else{tempDir =(int)(-90 - line.direction());}
				  		break;
					case 'r':
				  		if(line.direction() >=0){tempDir=(int)(-90 - line.direction());}
				  		else{tempDir =(int)(90 - line.direction());}
						break;
				}
				break;
				
		}//end of switch(spielRichtung)
		
		return tempDir;
	}//end of absDirection()
		
			
		
	
	
	
	
	/**
	 * Methode um im kartesischen Koordinatensystem einen Vektor auf einen 
	 * Punkt zu berechnen. Dazu braucht sie den absolutene Winkel 
	 * und ein Object dessen Entfehrnung und Winkel zum player bekannt sind. 
	 **/	
	private double[] absVektorAuf(double absDir, double distance, double direction)
	{ 		
		double totalDir = absDir + direction;
		//normalisierung
		if(totalDir>180)
			totalDir = totalDir - 360;
		if(totalDir<-180)
			totalDir = totalDir + 360;
		if(spielRichtung.equals("r"))
		{
			return(new double[] 
			{
					(distance * Math.cos(totalDir*Math.PI/180))
					,(distance * Math.sin(totalDir*Math.PI/180))}
			);	
		}
		else
		{
			//r -> l :die nullrichtung ist verdreht...
			return(new double[] {(distance * -Math.cos(totalDir*Math.PI/180))
			                    ,(distance * -Math.sin(totalDir*Math.PI/180))});
		}
	}
		
	
	
	
	
	/**
	 * Methode um dem WeltModel VisualEvents zu uebergeben und die darin
	 * enthaltenen Informationen in ObjektListen abzuspeichern
	 * Falls es fixe Objecte sind werden sie in einer absRPList gespeichert
	 * Falls es mobile Objecte sind werden sie in einer relOPList gespeichert
	 * Jetzt wird mithilfe der fixen Objekte in absRPList die abse Position des 
	 * Spielers berechnet.
	 * Erst jetzt kann den Objecten in der relOPList auch ein absolutener Wert 
	 * zugeordnet werde. Diese werden dann schliesslich der absRPList hinzugefuegt
	 **/
	public void update(VisualEvent ve)
	{
		
		//Used to hold the only visible line
		ObjectPerception line = null;
		//Used to store the nearest Flag
		ReferencePoint nearest = null;
		//Holds the absolute Direction
		double absDir = 361;//dummy value
		
		// reset lists, ball and player info;
		this.ball = null;
		this.player = null;
		this.absRPList.clear();
		this.relOPList.clear();
		
		//cycle through all visible objects
		for(Enumeration e = ve.elements() ; e.hasMoreElements() ; )
		{
			ObjectPerception objectPerception = (ObjectPerception)e.nextElement();
			
			if(objectPerception.time() > time)time = objectPerception.time();
				
			
			switch(objectPerception.name().charAt(0))
			{	
				case 'b'://found the ball
					relOPList.add(objectPerception);
					break;
				case 'l'://Found a line
					line = objectPerception;
					absDir = absDirection(line);
					break;
				case 'g': // finden goals	
					relOPList.add(objectPerception);
					break;
				case 'f':
					//for goals/flags the absolute coordinates x and y are already given in 
					//double subscripted array flagCoord. Cycle through all the flags 
					//given in array flags...
					for( int i = 0 ; i<flags.length ; i++)
					{
						if(objectPerception.name().equals(flags[i].name()))
						{
							//create a new ReferencePoint containing the found flag
							ReferencePoint flag = new ReferencePoint(
																	objectPerception.time()
																	,objectPerception.name()
																	,objectPerception.distance()
																	,objectPerception.direction()
																	,flags[i].getX()
																	,flags[i].getY());
							//is this flag the nearest?
							if(nearest == null || nearest.distance() > flag.distance())
							{
								nearest = flag;
							}
							
							absRPList.add(flag);
						}
					}
					break;  
					
				case 'p'://found a co-/opponent player
					relOPList.add(objectPerception);
					break;	
					
			}//end of switch()		
		}//end of for-loop
		
		
		
		
		//calculate absolutePosition if we did see a flag
		if(nearest != null)
		{
			//hol dir den vektor von dir auf die "nearest" flagge
			double[] vektorAufNearest = absVektorAuf(absDir, nearest.distance(), nearest.direction());
			//ziehe diesen vektor von dem vektor auf die flagge ab.
			double x = nearest.getX() - vektorAufNearest[0];
			double y = nearest.getY() - vektorAufNearest[1];
			double[] playerCoord = new double[] { x, y }; 
			player = new ReferencePoint(this.time,"i",0,absDir,playerCoord[0], playerCoord[1]);
			absRPList.add(player); 
		}
		
		
		
		//Now we need to use the absRPList to calculate 
		//the absolute coordinates for all elements in the relOPList
		for(Enumeration e = relOPList.elements() ; e.hasMoreElements() ; )
		{
			ObjectPerception op = (ObjectPerception)e.nextElement();
			//berechne den vektor vom eigenen player auf das mobile element
			double[] vektorAufElement = absVektorAuf(absDir, op.distance(), op.direction());
			//addiere diesen zum vektor auf die eigene absolute position
			double x = player.getX() + vektorAufElement[0];
			double y = player.getY() + vektorAufElement[1];
			ReferencePoint rp = new ReferencePoint(
													op.time()
													,op.name()
													,op.distance()
													,op.direction()
													,x
													,y
													);
			if(rp.name().equals("b"))
			{
				this.ball = rp;
			}
			absRPList.add(rp);
		}		
		
		if(graphics != null)
		{
			graphics.update(absRPList);
		}
					
	}//end of update()
	
}//end of class WeltModel

